using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;


namespace CsDemo {
    /// <summary>
    /// A VERY simple class for a textbox that accepts only
    /// Hex Chars [0..9, A..F]
    /// There is not enough Error-checking here, don't use in your own 
    /// projects!!!!!!!!!!!!!!!!!
    /// Nothing IOWarrior-specific in here.
    /// </summary>
    public partial class HexTextBox : UserControl {
        private bool validKey;

        public HexTextBox() {
            InitializeComponent();
            tb.Text="00";
            tb.MaxLength=2;
            tb.KeyPress+=new KeyPressEventHandler(tb_KeyPress);
            tb.KeyDown+=new KeyEventHandler(tb_KeyDown);
            tb.KeyUp+=new KeyEventHandler(tb_KeyUp);
        }

        protected void tb_KeyUp(object sender, KeyEventArgs e) {
            
        }

        protected void tb_KeyPress(object sender, KeyPressEventArgs e) {
            char c=char.ToUpper(e.KeyChar);
            validKey=false;
            if(char.IsDigit(c) || c=='A' || c=='B' || c=='C' || c=='D' || c=='E' || c=='F') {
                validKey=true;
                e.Handled=false;
                e.KeyChar=c;
            }
            else if(c.Equals((char)((int)Keys.Back)) || c.Equals((char)((int)Keys.Delete))) {
                validKey=true;
                e.Handled=false;
            }
            else
                e.Handled=true;
        }

        protected void tb_KeyDown(object sender, KeyEventArgs e) {
            if(!validKey)
                e.Handled=true;
        }

        /// <summary>
        /// Gets the current text as a byte value
        /// </summary>
        /// <returns>The byte for the Hexvalue</returns>
        public byte getHexValue() {
            if(tb.Text==null || tb.Text=="") {
                tb.Text="00";
                return 0;
            }
            return byte.Parse(tb.Text, System.Globalization.NumberStyles.AllowHexSpecifier);
        }

        /// <summary>
        /// Print correct value when focus is lost. Empty fields default to 00.
        /// If only one character was typed this is the lower nibble of the byte.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void HexTextBox_Leave(object sender, EventArgs e) {
           if(tb.Text==null || tb.Text=="") {
                tb.Text="00";
           }
           if(tb.Text.Length==1) {
               tb.Text="0"+tb.Text;
           }
        }
    }
}
